.\" $XFree86: xc/programs/Xserver/hw/xfree86/drivers/mediaq/mediaq,v 1.13 2000/03/07 01:37:49 dawes Exp $ 
.TH MGA 4 "Version 4.0"  "XFree86"
.SH NAME
mediaq \- MediaQ video driver
.SH SYNOPSIS
.B "Section ""Device"""
.br
.BI "  Identifier """  devname """"
.br
.B  "  Driver ""mediaq"""
.br
\ \ ...
.br
.B EndSection
.SH DESCRIPTION
.B mediaq
is an XFree86 driver for MediaQ video cards.  The driver is fully
accelerated, and provides support for the following framebuffer depths:
8, 16, 24, and 32 mode.  All visual types are supported for depth 8, 
and both TrueColor and DirectColor visuals are supported for the other 
depths. Multi-head configurations are supported.
.SH SUPPORTED HARDWARE
The
.B mediaq
driver supports PCI based on the following MediaQ chips:
.TP 12
.B MQ200
MediaQ-MQ200
.SH CONFIGURATION DETAILS
Please refer to XF86Config(5x) for general configuration
details.  This section only covers configuration details specific to this
driver.
.PP
The driver auto-detects the chipset type, but the following
.B ChipSet
names may optionally be specified in the config file
.B """Device"""
section, and will override the auto-detection:
.PP
.RS 4
"mq200"
.RE
.PP
The driver will auto-detect the amount of video memory present for all
chips except the Millennium II.  In the Millennium II case it defaults
to 4096\ kBytes.  When using a Millennium II, the actual amount of video
memory should be specified with a
.B VideoRam
entry in the config file
.B """Device"""
section.
.PP
The following driver
.B Options
are supported:
.TP
.BI "Option ""ColorKey"" """ integer """
Set the colormap index used for the transparency key for the depth 8 plane
when operating in 8+24 overlay mode.  The value must be in the range
2\-255.  Default: 255.
.TP
.BI "Option ""HWCursor"" """ boolean """
Enable or disable the HW cursor.  Default: on.
.TP
.BI "Option ""MGASDRAM"" """ boolean """
Specify whether G100 and G200 cards have SDRAM.  The driver attempts to
auto-detect this based on the card's PCI subsystem ID.  This option may
be used to override that auto-detection.  The mga driver is not able to 
auto-detect the prescence SDRAM on secondary heads in multihead configurations.
Default: auto-detected.
.TP
.BI "Option ""NoAccel"" """ boolean """
Disable or enable acceleration.  Default: acceleration is enabled.
.TP
.BI "Option ""OverclockMem""
Set clocks to values used by some commercial X-Servers (G100, G200 and G400
only).  Default: off.
.TP
.BI "Option ""Overlay""
Enable 8+24 overlay mode.  Only appropriate for depth 24.
.RB ( Note: 
the G100 is unaccelerated in the 8+24 overlay mode due to a missing 
hardware feature) Default: off.
.TP
.BI "Option ""PciRetry"" """ boolean """
Enable or disable PCI retries.  Default: off.
.TP
.BI "Option ""Rotate"" ""CW""
.TP
.BI "Option ""Rotate"" ""CCW""
Rotate the display clockwise or counterclockwise.  This mode is unaccelerated.
Default: no rotation.
.TP
.BI "Option ""ShadowFB"" """ boolean """
Enable or disable use of the shadow framebuffer layer.  See
shadowfb(4) for further information.  Default: off.
.TP
.BI "Option ""SyncOnGreen"" """ boolean """
Enable or disable combining the sync signals with the green signal.
Default: off.
.TP
.BI "Option ""UseFBDev"" """ boolean """
Enable or disable use of on OS-specific fb interface (and is not supported
on all OSs).  See fbdevhw(4) for further information.
Default: off.
.TP
.BI "Option ""VideoKey"" """ integer """
This sets the default pixel value for the YUV video overlay key.
Default: undefined.
.SH "SEE ALSO"
XFree86(1), XF86Config(5x), xf86config(1), Xserver(1), X(1)
.SH AUTHORS
Authors include: Radoslaw Kapitan, Mark Vojkovich, and also David Dawes, Guy
Desbief, Dirk Hohndel, Doug Merritt, Andrew E. Mileski, Andrew van der Stock,
Leonard N. Zubkoff.
