/* $XFree86: xc/programs/Xserver/hw/xfree86/drivers/MQ/MQ_hwcurs.c,v 1.9 1999/03/14 03:22:00 dawes Exp $ */

/* All drivers should typically include these */
#include "xf86.h"
#include "xf86_OSproc.h"
#include "xf86_ansic.h"

/* Drivers for PCI hardware need this */
#include "xf86Pci.h"
#include "xf86PciInfo.h"

#include "mq.h"
#include "mqplat.h"
#include "mq2hw.h"

//static void MQLoadPalette(ScrnInfoPtr, int, int*, LOCO*, VisualPtr);
//static void MQSavePalette(ScrnInfoPtr, unsigned char*);
//static void MQRestorePalette(ScrnInfoPtr, unsigned char*);
//static void MQRamdacInit(ScrnInfoPtr);
static void MQSave(ScrnInfoPtr, Bool);
static void MQRestore(ScrnInfoPtr, Bool);
//static Bool MQInit(ScrnInfoPtr, DisplayModePtr);
static Bool MQUseHWCursor(ScreenPtr pScrn, CursorPtr pCurs);
static void MQLoadCursorImage( ScrnInfoPtr pScrn, unsigned char *src);
static void MQShowCursor(ScrnInfoPtr pScrn);
static void MQHideCursor(ScrnInfoPtr pScrn);
static void MQSetCursorPosition( ScrnInfoPtr pScrn, int x, int y);
static void MQSetCursorColors( ScrnInfoPtr pScrn, int bg, int fg);

Bool 
MQHWCursorInit(ScreenPtr pScreen)
{
    ScrnInfoPtr pScrn = xf86Screens[pScreen->myNum];
    MQPtr pMQ = MQPTR(pScrn);
    //MQRamdacPtr MQdac = &pMQ->Dac;
    xf86CursorInfoPtr infoPtr;

    //if (!MQdac->isHwCursor) 
    //    return FALSE;

    infoPtr = xf86CreateCursorInfoRec();
    if(!infoPtr)
    	return FALSE;
    
    pMQ->CursorInfoRec = infoPtr;

    infoPtr->MaxWidth = 64;
    infoPtr->MaxHeight = 64;
#if 1
    //infoPtr->LoadPalette 	= MQLoadPalette;
    infoPtr->SetCursorColors	= MQSetCursorColors;
    infoPtr->SetCursorPosition	= MQSetCursorPosition;
    infoPtr->LoadCursorImage	= MQLoadCursorImage;
    infoPtr->HideCursor		= MQHideCursor;
    infoPtr->ShowCursor		= MQShowCursor;
    infoPtr->UseHWCursor	= MQUseHWCursor;
    infoPtr->Flags		= HARDWARE_CURSOR_SOURCE_MASK_INTERLEAVE_16
    				 | HARDWARE_CURSOR_SWAP_SOURCE_AND_MASK
				 | HARDWARE_CURSOR_AND_SOURCE_WITH_MASK
				 | HARDWARE_CURSOR_INVERT_MASK
       				 | HARDWARE_CURSOR_TRUECOLOR_AT_8BPP;
#else
    infoPtr->Flags = MQdac->CursorFlags;
    infoPtr->SetCursorColors = MQdac->SetCursorColors;
    infoPtr->SetCursorPosition = MQdac->SetCursorPosition;
    infoPtr->LoadCursorImage = MQdac->LoadCursorImage;
    infoPtr->HideCursor = MQdac->HideCursor;
    infoPtr->ShowCursor = MQdac->ShowCursor;
    infoPtr->UseHWCursor = MQdac->UseHWCursor;
#endif

    return(xf86InitCursor(pScreen, infoPtr));
}

/*
 * MQInit --
 *
 * The 'mode' parameter describes the video mode.	The 'mode' structure 
 * as well as the 'vga256InfoRec' structure can be dereferenced for
 * information that is needed to initialize the mode.	The 'new' macro
 * (see definition above) is used to simply fill in the structure.
 */
#if 0
static Bool
MQInit(ScrnInfoPtr pScrn, DisplayModePtr mode)
{
    //MQPtr pMQ = MQPTR(pScrn);
    //ErrorF("MQInit..%d\n", pMQ->CurrentLayout.bitsPerPixel);
    return(TRUE);
}
#endif

/*
 * MQRestore
 *
 * This function restores a video mode.	 It basically writes out all of
 * the registers that have previously been saved in the vgaMQRec data 
 * structure.
 */
static void 
MQRestore(ScrnInfoPtr pScrn, Bool restoreFonts)
{
    //MQPtr pMQ = MQPTR(pScrn);
    //Do nothing for now.
}

/*
 * MQSave
 *
 * This function saves the video state.
 */
static void
MQSave(ScrnInfoPtr pScrn, Bool saveFonts)
{
    //MQPtr pMQ = MQPTR(pScrn);
    //Do nothing for now.
}


static void
MQLoadCursorImage(
    ScrnInfoPtr pScrn, 
    unsigned char *src
)
{
    MQPtr pMQ = MQPTR(pScrn);
    unsigned long *ulsrc;
    unsigned long *ulcur; 
    int i;

    ulsrc = (unsigned long *)src;
    ulcur = (ULONG *)(pMQ->FbBase + (MQ200_FB_SIZE - 1024));

    for (i=0; i<256; i++)
        *ulcur++ = *ulsrc++;
}

static void 
MQShowCursor(ScrnInfoPtr pScrn)
{
    MQPtr pMQ = MQPTR(pScrn);
    unsigned long regdata;
    
    /* Enable cursor */
    regdata = gcREAD(GC1_CONTROL) | HC_ENABLE;
    gcREG(GC1_CONTROL, regdata);
    if (pMQ->MQFlag & USE_2GCs)
    {
	regdata = gcREAD(GC2_CONTROL) | HC_ENABLE;
	gcREG(GC2_CONTROL, regdata);
    }
}

static void
MQHideCursor(ScrnInfoPtr pScrn)
{
    MQPtr pMQ = MQPTR(pScrn);
    unsigned long regdata;

    /* Disable cursor */
    regdata = gcREAD(GC1_CONTROL) & HC_DISABLE;
    if (pMQ->MQFlag & USE_2GCs)
    {
	regdata = gcREAD(GC2_CONTROL) | HC_DISABLE;
	gcREG(GC2_CONTROL, regdata);
    }
}

static void
MQSetCursorPosition(
   ScrnInfoPtr pScrn, 
   int x, int y
)
{
    MQPtr pMQ = MQPTR(pScrn);
    unsigned long pos;
    pos = ((unsigned long)y << 16) | (unsigned long)x;
    gcREG(HW_CURSOR1_POS, pos);
}

static void
MQSetCursorColors(
   ScrnInfoPtr pScrn, 
   int bg, int fg
)
{
    MQPtr pMQ = MQPTR(pScrn);

    /* Background color */
    gcREG(HW_CURSOR1_BGCLR, (unsigned long)bg);
    gcREG(HW_CURSOR2_BGCLR, (unsigned long)bg);

    /* Foreground color */
    gcREG(HW_CURSOR1_FGCLR, (unsigned long)fg);
    gcREG(HW_CURSOR2_FGCLR, (unsigned long)fg);
}

static Bool 
MQUseHWCursor(ScreenPtr pScrn, CursorPtr pCurs)
{
    //ErrorF("MQUseHWCursor..\n");
    return TRUE;
}

#if 0
static void
MQRamdacInit(ScrnInfoPtr pScrn)
{
    MQPtr pMQ;
    MQRamdacPtr MQdac;

    //ErrorF("MQRamdacInit..\n");
    pMQ = MQPTR(pScrn);
    MQdac = &pMQ->Dac;

    MQdac->isHwCursor		= TRUE;
    MQdac->CursorMaxWidth	= 64;
    MQdac->CursorMaxHeight	= 64;
    MQdac->SetCursorColors	= MQSetCursorColors;
    MQdac->SetCursorPosition	= MQSetCursorPosition;
    MQdac->LoadCursorImage	= MQLoadCursorImage;
    MQdac->HideCursor		= MQHideCursor;
    MQdac->ShowCursor		= MQShowCursor;
    MQdac->UseHWCursor		= MQUseHWCursor;
    MQdac->CursorFlags		= HARDWARE_CURSOR_SOURCE_MASK_INTERLEAVE_16
    				 | HARDWARE_CURSOR_SWAP_SOURCE_AND_MASK
				 | HARDWARE_CURSOR_AND_SOURCE_WITH_MASK
				 | HARDWARE_CURSOR_INVERT_MASK
       				 | HARDWARE_CURSOR_TRUECOLOR_AT_8BPP;

    MQdac->LoadPalette 	= MQLoadPalette;
}
#endif

void MQLoadPalette(
    ScrnInfoPtr pScrn, 
    int numColors, 
    int *indices,
    LOCO *colors,
    VisualPtr pVisual
)
{
    MQPtr pMQ = MQPTR(pScrn);
    void *pMQMMIO = pMQ->IOBase;
    ULONG      gccontrol, palVal;
    int        i, index;
    //extern void invblank(void *);

    //ErrorF("MQLoadPalette..:%d, %d\n", pVisual->nplanes, numColors);

    //if(pVisual->nplanes != 8)
    //	return;

#if 0
	gccontrol = READ32(GC2_CONTROL);
	/* Ensure vertical blank in progress before DAC access if both GCs on */
	if (gccontrol & GC_ENABLE)
	{
		REG32(INT_MASK_REG,UM_GC2_VDE_F);
		invblank(pMQMMIO);
	}
	else
	{
		gccontrol = READ32(GC1_CONTROL);
		if (gccontrol & GC_ENABLE)
		{
			REG32(INT_MASK_REG,UM_GC1_VDE_F);
			invblank(pMQMMIO);
		}
	}
#endif

    for ( i = 0; i < numColors; i++ )
    {
        index = indices[i];
#if 0
        palVal = (ULONG)(colors[index].blue)
                | ((ULONG)(colors[index].green) << 8)
                | ((ULONG)(colors[index].red) << 16);
#else
        palVal = (ULONG)(colors[index].red)
                | ((ULONG)(colors[index].green) << 8)
                | ((ULONG)(colors[index].blue) << 16);
#endif
        REG32_PAL(index, palVal);
    }
}


static void
MQSavePalette(ScrnInfoPtr pScrn, unsigned char* pntr)
{
    MQPtr pMQ = MQPTR(pScrn);
    void  *pMQMMIO = pMQ->IOBase;
    ULONG i, palVal;

    //ErrorF("MQSavePalette..\n");

    for( i = 0; i < 256; i++ )
    {
        palVal = READ32_PAL(i);
        *pntr++ = palVal & 0xFFL;
        *pntr++ = (palVal >> 8) & 0xFFL;
        *pntr++ = (palVal >> 16) & 0xFFL;
    }
}

static void
MQRestorePalette(ScrnInfoPtr pScrn, unsigned char* pntr)
{
    MQPtr pMQ = MQPTR(pScrn);
    void  *pMQMMIO = pMQ->IOBase;
    ULONG i, palVal;

    //ErrorF("MQRestorePalette..\n");
    for( i = 0; i < 256; i++ )
    {
        palVal = (ULONG)*pntr++
                | ((ULONG)*pntr++ << 8)
                | ((ULONG)*pntr++ << 16);
        REG32_PAL(i, palVal);
    }
}


void MQSetupFuncs(ScrnInfoPtr pScrn)
{
   MQPtr pMQ = MQPTR(pScrn);
   //ErrorF("MQSetupFuncs..\n");

   //pMQ->PreInit = MQRamdacInit;
   pMQ->Save = MQSave;
   pMQ->Restore = MQRestore;
   //pMQ->ModeInit = MQInit;
}
